=== debian/changelog ===
drogon (1.8.4+ds-1build1) mantic; urgency=medium

  * Rebuild against new libyaml-cpp0.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Sep 2023 07:18:41 +0200

drogon (1.8.4+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1037495)
  * Repack to drop third_party directory

 -- Pierre-Elliott Bécue <peb@debian.org>  Mon, 26 Jun 2023 22:27:40 +0200
