## drogon 1.8.7%2Bds

=== debian/changelog ===
drogon (1.8.7+ds-1) unstable; urgency=medium

  * Drop .github and .gitmodules from upstream source
  * New upstream release 1.8.7+ds
  * Fix typo on copyright path

 -- Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>  Thu, 26 Oct 2023 21:16:37 +0200

drogon (1.8.4+ds-2) unstable; urgency=medium

  * Add lib/inc/drogon/version.h to debian/clean (Closes: #1044560)
  * Add a debian/watch file

 -- Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>  Wed, 13 Sep 2023 16:00:57 +0200
