## drogon 1.8.7+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,8 @@
 
 message(STATUS "compiler: " ${CMAKE_CXX_COMPILER_ID})
 
-# If your cross compile is failing, you should set
-# CMAKE_SYSTEM_NAME in your toolchain file
-if (NOT CMAKE_CROSSCOMPILING)
-    set(BUILD_PROGRAMS ON)
-else ()
-    set(BUILD_PROGRAMS OFF)
-endif ()
-
-option(BUILD_CTL "Build drogon_ctl" ${BUILD_PROGRAMS})
-option(BUILD_EXAMPLES "Build examples" ${BUILD_PROGRAMS})
+option(BUILD_CTL "Build drogon_ctl" ON)
+option(BUILD_EXAMPLES "Build examples" ON)
 option(BUILD_ORM "Build orm" ON)
 option(COZ_PROFILING "Use coz for profiling" OFF)
 option(BUILD_SHARED_LIBS "Build drogon as a shared lib" OFF)
@@ -31,7 +23,7 @@
 
 set(DROGON_MAJOR_VERSION 1)
 set(DROGON_MINOR_VERSION 8)
-set(DROGON_PATCH_VERSION 4)
+set(DROGON_PATCH_VERSION 7)
 set(DROGON_VERSION
     ${DROGON_MAJOR_VERSION}.${DROGON_MINOR_VERSION}.${DROGON_PATCH_VERSION})
 set(DROGON_VERSION_STRING "${DROGON_VERSION}")
@@ -215,12 +207,23 @@
 if(BUILD_YAML_CONFIG)
     find_package(yaml-cpp QUIET)
     if(yaml-cpp_FOUND)
-    message(STATUS "yaml-cpp found")
-    target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LIBRARIES})
-    target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
+        if (NOT YAML_CPP_LIBRARIES)
+            find_library(YAML_CPP_LINK_LIBRARY "yaml-cpp")
+            if(NOT YAML_CPP_LINK_LIBRARY)
+                message(STATUS "yaml-cpp not used")
+            else()
+                message(STATUS "yaml-cpp found ")
+                target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LINK_LIBRARY})
+                target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
+            endif()
+        else()
+            message(STATUS "yaml-cpp found ")
+            target_link_libraries(${PROJECT_NAME} PUBLIC ${YAML_CPP_LIBRARIES})
+            target_compile_definitions(${PROJECT_NAME} PUBLIC HAS_YAML_CPP)
+        endif()
     else()
-    message(STATUS "yaml-cpp not used")
-    endif(yaml-cpp_FOUND)
+        message(STATUS "yaml-cpp not used")
+    endif()
 else()
     message(STATUS "yaml-cpp not used")
 endif(BUILD_YAML_CONFIG)
@@ -233,16 +236,18 @@
 
     try_compile(normal_uuid ${CMAKE_BINARY_DIR}/cmaketest
         ${PROJECT_SOURCE_DIR}/cmake/tests/normal_uuid_lib_test.cc
-        LINK_LIBRARIES UUID_lib)
+        LINK_LIBRARIES UUID_lib
+        OUTPUT_VARIABLE NORMAL_UUID_COMPILE_OUTPUT)
     try_compile(ossp_uuid ${CMAKE_BINARY_DIR}/cmaketest
         ${PROJECT_SOURCE_DIR}/cmake/tests/ossp_uuid_lib_test.cc
-        LINK_LIBRARIES UUID_lib)
+        LINK_LIBRARIES UUID_lib
+        OUTPUT_VARIABLE OSSP_UUID_COMPILE_OUTPUT)
     if (normal_uuid)
         add_definitions(-DUSE_OSSP_UUID=0)
     elseif (ossp_uuid)
         add_definitions(-DUSE_OSSP_UUID=1)
     else ()
-        message(FATAL_ERROR "uuid lib error")
+        message(FATAL_ERROR "uuid lib error:\n${NORMAL_UUID_COMPILE_OUTPUT}\n${OSSP_UUID_COMPILE_OUTPUT}")
     endif ()
 endif (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD"
     AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD"
@@ -287,6 +292,7 @@
     lib/src/PluginsManager.cc
     lib/src/RangeParser.cc
     lib/src/SecureSSLRedirector.cc
+    lib/src/GlobalFilters.cc
     lib/src/AccessLogger.cc
     lib/src/RealIpResolver.cc
     lib/src/SessionManager.cc
@@ -301,22 +307,7 @@
     lib/src/SlidingWindowRateLimiter.cc
     lib/src/TokenBucketRateLimiter.cc
     lib/src/Hodor.cc
+    lib/src/SlashRemover.cc
     lib/src/drogon_test.cc
     lib/src/ConfigAdapterManager.cc
     lib/src/JsonConfigAdapter.cc
-    lib/src/YamlConfigAdapter.cc)
-set(private_headers
-    lib/src/AOPAdvice.h
-    lib/src/CacheFile.h
-    lib/src/ConfigLoader.h
-    lib/src/filesystem.h
-    lib/src/FiltersFunction.h
-    lib/src/HttpAppFrameworkImpl.h
-    lib/src/HttpClientImpl.h
-    lib/src/HttpControllersRouter.h
-    lib/src/HttpFileImpl.h
-    lib/src/HttpFileUploadRequest.h
-    lib/src/HttpMessageBody.h
-    lib/src/HttpRequestImpl.h
-    lib/src/HttpRequestParser.h
-    lib/src/HttpResponseImpl.h
