=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: drogon
-Maintainer: Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>
 Section: web
 Priority: optional
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
   chrpath,
   cmake,
   debhelper-compat (=13),
@@ -24,7 +25,10 @@
 Homepage: https://github.com/drogonframework/drogon
 Rules-Requires-Root: no
 
-Package: libdrogon1
+Package: libdrogon1t64
+Provides: ${t64:Provides}
+Replaces: libdrogon1
+Breaks: libdrogon1 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++14/17-based HTTP application framework
@@ -38,7 +42,7 @@
 
 Package: libdrogon-dev
 Architecture: any
-Depends: libdrogon1 (= ${binary:Version}), libtrantor-dev, ${misc:Depends}
+Depends: libdrogon1t64 (= ${binary:Version}), libtrantor-dev, ${misc:Depends}
 Description: C++14/17-based HTTP application framework
  Drogon can be used to easily build various types of web application server
  programs using C++.
@@ -50,7 +54,7 @@
 
 Package: drogon
 Architecture: any
-Depends: libdrogon1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libdrogon1t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: C++14/17-based HTTP application framework
  Drogon can be used to easily build various types of web application server
  programs using C++.
